/* ========================================
 *
 * GT-521F32 
 * Optical Fingerprint Recognition EMBEDDED module
 * ========================================
*/
#ifndef _GT_521F32_H_
#define _GT_521F32_H_
#include "project.h"
    
#define TEMPLATE_SIZE 498

typedef struct _cmd_packet_st {
    uint16_t head ;
    uint16_t device_id ;
    uint32_t parameter ;
    uint16_t command ;
    uint16_t check_sum ;
} Command_Packet_Type ;

typedef struct _res_packet_st {
    uint16_t head ;
    uint16_t device_id ;
    uint32_t parameter ;
    uint16_t response ;
    uint16_t check_sum ;
} Response_Packet_Type ;

typedef struct _data_packet_st {
    uint16_t head ;
    uint16_t device_id ;
    uint8_t *data ; /* variable length */
    uint16_t check_sum ;
} Data_Packet_Type ;

extern Command_Packet_Type _cmd_packet ;
extern Response_Packet_Type _res_packet ;
extern Data_Packet_Type _data_packet ;

int  fps_send_command_packet(Command_Packet_Type *cmd) ;
int  fps_recv_response_packet(Response_Packet_Type *res) ;
int  fps_send_data_packet(Data_Packet_Type *data, int num_data) ;
int  fps_recv_data_packet(Data_Packet_Type *data, int num_data) ;
int  fps_recv_and_dump_packet(Data_Packet_Type *data, int num_data) ; 
void fps_print_devinfo(uint8_t buf[]) ;
int  fps_open(int extra_info) ;
int  fps_close(void) ;
int  fps_first_search(void) ;
int  fps_led(int led_on) ;
int  fps_change_baudrate(uint32_t baudrate) ;
int  fps_get_enrolled_count(void) ;
int  fps_check_enrolled(int id) ;
int  fps_start_enrollment(int id, int check_duplication) ;
int  fps_enroll1(void) ;
int  fps_enroll2(void) ;
int  fps_enroll3(void) ;
int  fps_is_finger_pressed(void) ;
int  fps_delete_id(int id) ;
int  fps_delete_all(void) ;
int  fps_verify(int id) ;
int  fps_identify(void) ;
int  fps_verify_template(int id, uint8_t template[]) ;
int  fps_identify_template(uint8_t template[]) ;
int  fps_capture_finger(int best_image) ;
int  fps_make_template(void) ;
int  fps_get_image(void) ;
int  fps_get_raw_image(void) ;
int  fps_get_template(int id, uint8_t template[]) ;
int  fps_set_template(int id, uint8_t template[], int check_duplication) ; 
// int  fps_download_database(void) ; /* obsolete, do nothing */
// int  fps_end_download(void) ; /* obsolete, do nothing */
int  fps_set_security_level(int level) ;
int  fps_get_security_level(void) ;
int  fps_enter_stadby(void) ;
int  fps_wake_up(void) ; /* send 0x00 and wait 20ms */
int  fps_identify_template2(uint8_t template[]) ;

#endif /* _GT_521F32_H_ */

/* [] END OF FILE */
