#include "project.h"
#include <stdio.h>
#include <string.h>
#include "utils.h"

extern char str[] ;
extern cmd_func_type cmd_list[] ;

int str2lower(char *str)
{
    int i = 0 ;
    for (i = 0 ; str && str[i] ; i++ ) {
        if (('A' <= str[i])&&(str[i] <= 'Z')) { /* Upper case */
            str[i] += 'a' - 'A' ;
        }
    }
    return(i) ;
}

int str2upper(char str[])
{
    int i = 0 ;
    for (i = 0 ; str && str[i] ; i++ ) {
        if (('a' <= str[i])&&(str[i] <= 'z')) { /* Upper case */
            str[i] -= ('a' - 'A') ;
        }
    }
    return(i) ;    
}

void print(char *str) 
{
    UART_PutString(str) ;
}

int get_string(char str[])
{
    char c ;
    int index = 0 ;
    
    while(index < STR_LENGTH) {
        if (UART_GetRxBufferSize() > 0) {
            c = UART_GetChar() ;

            if (c == BS) {
                if (index > 0) {
                    str[--index] = (char)NULL ;
                    UART_PutString("\b \b") ;
                }
            } else if ((c == CR)||(c == LF)||(c == TAB)||(c == SPACE)) {
                UART_PutChar(c) ;
                break ;
            } else {
                UART_PutChar(c) ;
                str[index++] = c ;
            }
        }
    }
    str[index] = (char)NULL ;
    
    return(index) ;
}

int get_line(char str[])
{
    char c ;
    int index = 0 ;
    
    while(index < STR_LENGTH) {
        if (UART_GetRxBufferSize() > 0) {
            c = UART_GetChar() ;

            if (c == BS) {
                if (index > 0) {
                    str[--index] = (char)NULL ;
                    UART_PutString("\b \b") ;
                }
            } else if ((c == CR)||(c == LF)) {
                UART_PutChar(c) ;
                break ;
            } else {
                UART_PutChar(c) ;
                str[index++] = c ;
            }
        }
    }
    str[index] = (char)NULL ;
    
    return(index) ;
}

FuncPtr get_func(char cmd[]) 
{
    int i = 0 ;
    str2lower(cmd) ;
    while(cmd_list[i].cmd) {
        if (strcmp(cmd, cmd_list[i].cmd) == 0) {
            return(cmd_list[i].func) ;
        }
        i++ ;
    }
    return( 0 ) ;
}

/* [] END OF FILE */
